using System;
using System.Drawing;
using System.Collections;
using System.Text;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Specialized;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;

namespace ConditionallySettingRowStyle
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(128, 112);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(560, 328);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.301.0.0";
			this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(768, 558);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		StringCollection items ;
		private void Form1_Load(object sender, System.EventArgs e)
		{

			

			items = new StringCollection();
			items.Add("One");
			items.Add("Two");
			items.Add("Three");
			items.Add("Four");
			items.Add("Five");
			items.Add("Six");
			items.Add("Seven");
			items.Add("Eight");
			items.Add("Nine");
			items.Add("Ten");


			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});

			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			ds.Relations.Add(parentToChild);

			this.gridGroupingControl1.DataSource = parentTable;
			this.gridGroupingControl1.Appearance.AnyRecordFieldCell.ReadOnly=true;
			this.gridGroupingControl1.GetTableDescriptor("ChildTable").Columns["Outcome"].Appearance.AnyRecordFieldCell.DataSource = items;
			this.gridGroupingControl1.GetTableDescriptor("ChildTable").Columns["Notes"].Appearance.AnyRecordFieldCell.DataSource = items;
		}
		
		private int numberParentRows = 5;
		private int numberChildRows = 20;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ApprovalState"));
			dt.Columns.Add(new DataColumn("CompletedDate"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Outcome"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("Role")); //upper case P
			dt.Columns.Add(new DataColumn("Notes")); //upper case P
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				if(i==2 || i==5)
					dr[3] = string.Format("other0",i);
				else
					dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);
				dt.Rows.Add(dr);
				
					
			}
		
			return dt;
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.Column != null && (e.TableCellIdentity.Column.MappingName == "Outcome" || e.TableCellIdentity.Column.MappingName == "Notes")&& e.TableCellIdentity.DisplayElement is GridRecordRow)
			{
				DataRowView dr  = e.TableCellIdentity.DisplayElement.ParentRecord.GetData() as DataRowView; // .GetValue("other");
				if(dr!=null && dr["Role"].Equals("other0"))
				{
					e.Style.BackColor=Color.Turquoise;
					e.Style.ReadOnly=false;
					e.Style.CellType = "ComboBox";
				}
				else
				{
					e.Style.BackColor=Color.White;
					e.Style.ReadOnly=true;
					e.Style.CellType = "TextBox";
				}
			}
		}

	}
}
